# Description: Cython module for encoding and decoding SWMM datetimes
# Created by: Caleb Buahin (EPA/ORD/CESER/WID)
# Created on: 2024-11-19

"""
This type stub file was generated by cyright.
"""

from typing import Any
from datetime import datetime

def encode_swmm_datetime(pdatetime: datetime) -> float:
    """
    Encode a datetime object into a SWMM datetime.

    The SWMM datetime is a float that represents the OLE Automation date
    format. The integer part of the float represents the number of days since
    12/31/1899. The decimal part of the float represents the fraction of the
    day. For example, 1.5 represents 1 day and 12 hours.

    :param pdatetime: datetime object to encode into a SWMM datetime float value
    :type pdatetime: datetime
    :return: SWMM datetime float value
    :rtype: float
    """
    ...

def decode_swmm_datetime(swmm_datetime: float) -> datetime:
    """
    Decode a SWMM datetime into a datetime object.

    The SWMM datetime is a double that represents the number of days since
    12/31/1899. The decimal part of the double represents the fraction of the
    day. For example, 1.5 represents 1 day and 12 hours.

    :param swmm_datetime: SWMM datetime double value to decode into a datetime object
    :type swmm_datetime: double
    :return: datetime object
    :rtype: datetime
    """
    ...

